-- $Id: //depot/Projects/StarWars_Expansion/Run/Data/Scripts/AI/BuildSpaceForcesPlan.lua#2 $
--/////////////////////////////////////////////////////////////////////////////////////////////////
--
-- (C) Petroglyph Games, Inc.
--
--
--  *****           **                          *                   *
--  *   **          *                           *                   *
--  *    *          *                           *                   *
--  *    *          *     *                 *   *          *        *
--  *   *     *** ******  * **  ****      ***   * *      * *****    * ***
--  *  **    *  *   *     **   *   **   **  *   *  *    * **   **   **   *
--  ***     *****   *     *   *     *  *    *   *  *   **  *    *   *    *
--  *       *       *     *   *     *  *    *   *   *  *   *    *   *    *
--  *       *       *     *   *     *  *    *   *   * **   *   *    *    *
--  *       **       *    *   **   *   **   *   *    **    *  *     *   *
-- **        ****     **  *    ****     *****   *    **    ***      *   *
--                                          *        *     *
--                                          *        *     *
--                                          *       *      *
--                                      *  *        *      *
--                                      ****       *       *
--
--/////////////////////////////////////////////////////////////////////////////////////////////////
-- C O N F I D E N T I A L   S O U R C E   C O D E -- D O   N O T   D I S T R I B U T E
--/////////////////////////////////////////////////////////////////////////////////////////////////
--
--              $File: //depot/Projects/StarWars_Expansion/Run/Data/Scripts/AI/BuildSpaceForcesPlan.lua $
--
--    Original Author: Steve_Copeland
--
--            $Author: James_Yarrow $
--
--            $Change: 45824 $
--
--          $DateTime: 2006/06/07 17:16:05 $
--
--          $Revision: #2 $
--
--/////////////////////////////////////////////////////////////////////////////////////////////////

require("pgevents")

-- Tell the script pooling system to pre-cache this number of scripts.
ScriptPoolCount = 6

function Definitions()
	Category = "Build_Space_Forces"
	IgnoreTarget = true
	
	--Fighters are omitted deliberately.  Since they're cheap, build fast and are quickly killed it's typically better
	--to build them as we need them to attack.  For defensive purposes we'll rely on space station garrisons for our fighter
	--needs
	TaskForce = {
	{
		"ReserveForce"
		,"DenyHeroAttach"
		,"TIE_Defender_Squadron = 1,5"
		,"TIE_Phantom_Squadron = 0,1"
		,"Missile_Gunboat_Squadron = 1,5"
		,"K_Wing_Squadron = 1,5"
		,"Rebel_X-Wing_Squadron = 1,3"
		,"Y-Wing_Squadron = 1,3"
		,"A_Wing_Squadron = 1,5"
		,"StarViper_Squadron = 1,4"
		,"Skipray_MkII_Squadron = 1,5"
		,"Skipray_Squadron = 1,4"
		,"Corvette = 1,8"
		,"Frigate = 1,5"
		,"Capital = 1,5"
                ,"SpaceHero = 0,1"
		,"Fleet_Com_Rebel_Team = 1,2"
		,"Fleet_Com_Empire_Team = 1,2"
		,"-Smuggler_Team_E"
		,"-Smuggler_Team_R"
		,"-Probe_Droid_Team"
		,"-Bounty_Hunter_Team_E"
		,"-Bounty_Hunter_Team_R"
		,"-Field_Com_Rebel_Team"
                ,"-Field_Com_Empire_Team"
                ,"-Underworld_Saboteur_Team"
	}
	}
	RequiredCategories = { "Corvette | Frigate | Capital" }
	AllowFreeStoreUnits = false
end

function ReserveForce_Thread()	
	ReserveForce.Set_As_Goal_System_Removable(false)
	BlockOnCommand(ReserveForce.Produce_Force())
	ReserveForce.Set_Plan_Result(true)
end
