-- $Id: //depot/Projects/StarWars_Expansion/Run/Data/Scripts/GameObject/interdictor.lua#3 $
--/////////////////////////////////////////////////////////////////////////////////////////////////

--              $File: //depot/Projects/StarWars_Expansion/Run/Data/Scripts/GameObject/interdictor.lua $

require("PGStateMachine")


function Definitions()

	ServiceRate = 1
	
	--MessageBox("script attached!")
	Define_State("State_Init", State_Init);
	Define_State("State_AI_Autofire", State_AI_Autofire)
	Define_State("State_Human_No_Autofire", State_Human_No_Autofire)
	Define_State("State_Human_Autofire", State_Human_Autofire)
	
	ability_name = "MISSILE_SHIELD"

end

function State_Init(message)

	-- prevent this from doing anything in galactic mode
	--MessageBox("%s, mode %s", tostring(Script), Get_Game_Mode())
	if Get_Game_Mode() ~= "Space" then
		ScriptExit()
	end
	
	-- prevent this from doing anything in galactic mode
		if Get_Game_Mode() == "Galactic" then
			ScriptExit()
		end

	-- Bail out if this is a human player
	if Object.Get_Owner().Is_Human() then
		ScriptExit()
	end
		
	if message == OnEnter then
		--MessageBox("%s--Object:%s", tostring(Script), tostring(Object))

		interdicting = false

	elseif message == OnUpdate then

		repeat
		
			-- The AI may not yet be initialized
			Sleep(1)
			enemy_is_retreating = EvaluatePerception("Enemy_Retreating", Object.Get_Owner())
		until (enemy_is_retreating ~= nil)

		-- Prevent the enemy from retreating, if they're trying to
		if (enemy_is_retreating ~= 0) and (not interdicting) then
			interdicting = true
			Sleep(GameRandom(3,8))
			--MessageBox("trying to interdict")
			Object.Activate_Ability("INTERDICT", true)
			Register_Timer(Cancel_Interdiction, 20)
		end

	end
end

function State_AI_Autofire(message)
	if message == OnUpdate then
		if Object.Is_Ability_Ready(ability_name) then
			enemy = FindDeadlyEnemy(Object)
			if TestValid(enemy) then
				projectile_types = enemy.Get_All_Projectile_Types()
				for _, projectile in pairs(projectile_types) do
					if projectile.Is_Affected_By_Missile_Shield() then
						Object.Activate_Ability(ability_name, true)
						return
					end
				end
			end
		end

		if Object.Get_Owner().Is_Human() then
			Set_Next_State("State_Human_No_Autofire")
		end				
	end		
end

function State_Human_No_Autofire(message)
	if message == OnUpdate then
		if Object.Is_Ability_Autofire(ability_name) then
			Set_Next_State("State_Human_Autofire")
		end		
	end
end

function State_Human_Autofire(message)
	if message == OnUpdate then
	
		if Object.Is_Ability_Autofire(ability_name) then
			if Object.Is_Ability_Ready(ability_name) then
				enemy = FindDeadlyEnemy(Object)
				if TestValid(enemy) then
					projectile_types = enemy.Get_All_Projectile_Types()
					if projectile_types then
						for _, projectile in pairs(projectile_types) do
							if projectile.Is_Affected_By_Missile_Shield() then
								Object.Activate_Ability(ability_name, true)
								return
							end
						end
					end
				end
			end
		else
			Set_Next_State("State_Human_No_Autofire")
		end
			
	end				
end

function Cancel_Interdiction()
	Object.Activate_Ability("INTERDICT", false)
	interdicting = false
end

function Under_Missile_Attack()
	deadly_enemy = FindDeadlyEnemy(Object)
	if TestValid(deadly_enemy) then
		enemy_type = deadly_enemy.Get_Type()
		if TestValid(deadly_enemy) and (enemy_type == marauder or enemy_type == broadside or enemy_type == eidolon) then
			return true
		end
	end
	return false
end

function Cancel_Missile_Shield()
	cancelling_shield = false
	
	if Under_Missile_Attack() then
		return
	end
	
	Object.Activate_Ability("MISSILE_SHIELD", false)
	using_missile_shield = false 	
end
